clear all
close all
global RBFtype;  % type of RBF see frbf.m
global RBFpar;   % parameter of RBF, see frbf.m
global RBFscale; % scale of RBF, see frbf.m
%
% RBFtype='g';  % basis function Gauss kernel
% RBFscale=1;   
% RBFpar=0;

%
RBFtype='g';  % basis function multiquadric kernel
RBFscale=1;   
RBFpar=-2; % only INVERSE multiquadrics are pos.def. 
%
% RBFtype='w'; % basis function Wendland kernel
% RBFscale=10;  % scale for Wendland must be larger  
% RBFpar=2; 
%
% -----------------------data sites-----------------------------
he=.02;   % h for evaluation grid
[dsites, ind, xee, yee, xe, ye]=cutcircle(he); % generates points
Np=length(xee(ind)) % number of points for evaluation
%
% Now the greedy Newton-based method for getting points
maxN=100;  % Maximal number of data sites used
Ptol=1.e-14; % tolerance for square (!) of power function
% Here is a PowerGreedy program.
% The power function is independent of the basis, so we can use the 
% greedy point selection program for the Newton basis:
plot(dsites(:,1),dsites(:,2),'.')
valfull=zeros(length(xe(:)),1);
v=zeros(Np,maxN);
ip=zeros(maxN,1);
z=frbf(0.0,0)*ones(Np,1);
[zm izm]=max(z)
iter=1;
ip(iter,1)=izm;
pw=[zm];
u=kermat(dsites,dsites(izm,:));
v(:,iter)=u/sqrt(z(izm,1));
valfull(ind)=v(:,iter);
figure
surf(xe,ye,reshape(valfull,size(xe))); % or surf or surfc 

w=v(:,iter).^2;
for iter=2:maxN
    [zm izm]=max(z-w)
    if zm<Ptol
        iter=iter-1;
        break;
    end
    pw=[pw zm];
    y=v(izm,1:iter)';
    u=kermat(dsites,dsites(izm,:))-v(:,1:iter)*y;
    v(:,iter)=u/sqrt((z(izm,1)-w(izm,1)));
    w=w+v(:,iter).^2;
    ip(iter,1)=izm;
    valfull(ind)=v(:,iter);
    figure
    surf(xe,ye,reshape(valfull,size(xe))); % or surf or surfc 
    % contour is good for checking symmetry and zeros
    % The following is only good for contour, 
    % and in particular made for
    % the Newton basis, since we distinguish between the 
    % points that are zeros for the i-th basis function
    % and the points that are not handled yet.
    %     hold on
    %     plot(dsites(mi(1:i-1),1),dsites(mi(1:i-1),2),'.',dsites(mi(i),1),dsites(mi(i),2),'kx',...
    %         dsites(mi(i+1:end),1),dsites(mi(i+1:end),2),'mx')
    % title(sprintf('%s basis function %d\n',textstring, i))
end
figure
semilogy(pw)
figure
% plot(dsites(:,1),dsites(:,2),'b.')
% hold on
plot(dsites(ip(1:iter,1),1),dsites(ip(1:iter,1),2),'ro')
axis equal



end


